#---
# Excerpted from "The ThoughtWorks Anthology",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/twa for more book information.
#---
require 'model'
require 'pp'
class RulesBuilder14
  def load aStream
    result = eval(aStream.join("\n"))
    return result.configuration
  end
end
class ConfigurationBuilder
  attr_reader :subject

  def self.item arg
    builder = ConfigurationBuilder.new
    builder.item arg
  end
  def initialize
    @subject = Configuration.new
  end
  def item arg
    result = ItemBuilder.new self, arg
    @subject.add_item result.subject
    return result
  end

end

class ItemBuilder
  attr_reader :subject, :parent

  def item arg
    @parent.item arg
  end
  def initialize parent, arg
    @parent = parent
    @subject = Item.new arg
  end

  def provides arg
    subject.add_provision arg.subject
    return self
  end
  def uses arg
    subject.add_usage arg.subject
    return self
  end

  def depends_on arg
    subject.add_dependency(configuration[arg])
    return self
  end
  def configuration
    return @parent.subject
  end

end

class Resources
  class << self
    def electricity power
      return ElectricityBuilder.new(power)
    end

    def acid
      return AcidBuilder.new
    end
  end
end

class AcidBuilder
  attr_reader :subject
  def initialize
    @subject = Acid.new
  end
  def type arg
    subject.type = arg
    self
  end
  def grade arg
    subject.grade = arg
    self
  end
end

class ElectricityBuilder
  attr_reader :subject
  def initialize arg
    @subject = Electricity.new arg
  end
end

    
